#!python
import sys
import os
import json

dirname = os.path.dirname(os.path.abspath(__file__))
dirname = os.path.join(dirname,"../")
sys.path.append(dirname)
from ngsqc.fastqc.FastQC import FastQC
from ngsqc.arranger.arranger import arranger
from ngsqc.reporter.reporter import report
from jbiot import jbiotWorker
import yaml
def fastQc(indict):
    indict = indict["fastqs"]
    prefix = "22"
    # load input files
    fqs = []
    for prex,pair in indict.items():
        for item in pair:
            fqs.append(item)

    # start pipeline 
    qcer = FastQC(fqs,prefix)
    qcer.byfastqc()
    qcer.byfastp()

    # arranger out file to attachment
    arr = arranger(prefix)
    arr.arrange()
    rdir = arr.report

    # auto report
    report(rdir,prefix)
    outdict = {}
    return outdict

class qcWorker(jbiotWorker):
    def handle_task(self,key,params):
        self.execMyfunc(fastQc,params)

def main(yml):
    fp = open(yml)
    indict = yaml.load(fp)
    fastQc(indict)

if __name__ == "__main__":

    usage = '''
Usage:
    fastQc.py -c <yml>
    fastQc.py -h | --help
    fastQc.py -v | --version

Options:
    -h --help                         print usage
    -v --version                      print version information
    -c --conf <yml>                   yaml file generated by smartFqs
    '''   

    from docopt import docopt
    args = docopt(usage) 
    yml = args["--conf"]
    main(yml) 

